void dse(const HRESULT dsresult)
{
	if (dsresult!=DS_OK) {error("DirectSound error"); gracefulexit();}
}

void dsd(const int x,const HRESULT dsresult)
{
	if (dsresult!=DS_OK)
	{
		char str[50];
		sprintf(str,"DirectSound error @ %d",x);
		error(str);
		gracefulexit();
	}
}

int directsoundsetup(const HWND winhandle)
{
	if (DirectSoundCreate(NULL,&lpds,NULL)!=DS_OK) return 1;
/*cj*/
	// Sets the _primary_ buffer to 44.1Khz 16-bit.

	// NB. This stops everthing sounding like the waves of a distant
	// ocean washing up on a beach that is made out of tin cans when
	// the volume of a sound is decreased. It also allows better high
	// frequency sound playing (like up to 44100hz).

	// NB. Not copied out of a book this time...

	if (IDirectSound_SetCooperativeLevel(lpds,winhandle,DSSCL_PRIORITY)!=DS_OK) return 1;
	// DDSCL_PRIMARY needed for primary buffer manipulation

	LPDIRECTSOUNDBUFFER lpdsbPrimary; // Setup primary buffer
	DSBUFFERDESC dsbdesc;
	memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));
    dsbdesc.dwSize = sizeof(DSBUFFERDESC);
    dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
    if (IDirectSound_CreateSoundBuffer(lpds, &dsbdesc, &lpdsbPrimary, NULL)!=DS_OK) return 1;

    WAVEFORMATEX wfx;		// Set the format of the primary buffer
    memset(&wfx, 0, sizeof(WAVEFORMATEX));
    wfx.wFormatTag = WAVE_FORMAT_PCM;
    wfx.nChannels = 2; // STEREO
    wfx.nSamplesPerSec = 44100; // 44.1Khz
    wfx.wBitsPerSample = 16; // 16 bit
    wfx.nBlockAlign = wfx.wBitsPerSample / 8 * wfx.nChannels;  // boring stuff
    wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
    IDirectSoundBuffer_SetFormat(lpdsbPrimary, &wfx);
/*/cj*/
	return 0;
}

LPDIRECTSOUNDBUFFER makebuffer(const int size,const int hertz)
{
	LPDIRECTSOUNDBUFFER ret;
	DSBUFFERDESC desc;
	WAVEFORMATEX wave;
	memset(&wave,0,sizeof(WAVEFORMATEX));
	wave.wFormatTag=WAVE_FORMAT_PCM;
	wave.nChannels=1;
	wave.nSamplesPerSec=hertz;
	wave.nBlockAlign=1;
	wave.nAvgBytesPerSec=wave.nSamplesPerSec*wave.nBlockAlign;
	wave.wBitsPerSample=8;
	wave.cbSize=0;
	memset(&desc,0,sizeof(DSBUFFERDESC));
	desc.dwSize=sizeof(DSBUFFERDESC);
	desc.dwFlags=DSBCAPS_CTRLDEFAULT|DSBCAPS_STATIC|DSBCAPS_LOCSOFTWARE;
	desc.dwBufferBytes=size;
	desc.lpwfxFormat=&wave;
	dsd(0,IDirectSound_CreateSoundBuffer(lpds,&desc,&ret,NULL));
	return ret;
}

void killbuffer(const LPDIRECTSOUNDBUFFER buf)
{
	if (buf) IDirectSoundBuffer_Release(buf);
}

void writesound(const unsigned char *array,const LPDIRECTSOUNDBUFFER buf,const long size)
{
	unsigned char *chunk1,*chunk2;
	long size1,size2;
	if (IDirectSoundBuffer_Lock(buf,0,size,
			(void **)&chunk1,&size1,
			(void **)&chunk2,&size2,DSBLOCK_ENTIREBUFFER)!=DS_OK)
		dsd(1,IDirectSoundBuffer_Lock(buf,0,size,
				(void **)&chunk1,&size1,(void **)&chunk2,&size2,0));
	// Write the data
	memcpy(chunk1,array,size1);
	memcpy(chunk2,array+size1,size2);
	dsd(2,IDirectSoundBuffer_Unlock(buf,chunk1,size1,chunk2,size2));
}

void stopsound(const LPDIRECTSOUNDBUFFER buf)
{
	dsd(3,IDirectSoundBuffer_Stop(buf));
}

void playsound(const LPDIRECTSOUNDBUFFER buf)
{
	dsd(4,IDirectSoundBuffer_Play(buf,0,0,0));
}

void loopsound(const LPDIRECTSOUNDBUFFER buf)
{
	dsd(5,IDirectSoundBuffer_Play(buf,0,0,DSBPLAY_LOOPING));
}
